<?php

namespace App\Services\Customer\Wallet;

use RuntimeException;
use App\Models\Customer\Wallet\PointModel;
use App\Helpers\Customer\Wallet\PointHelper;
use App\Forms\Customer\Wallet\PointForm;
use App\Entities\Customer\Wallet\PointEntity;
use App\DTOs\Customer\Wallet\PointDTO;

class PointService extends WalletService
{
    private $_form = null;
    private $_helper = null;
    public function __construct(PointModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('Point');
    }
    protected function getDTOClass(): string
    {
        return PointDTO::class;
    }
    public function createDTO(array $formDatas): PointDTO
    {
        return new PointDTO($formDatas);
    }
    public function getEntityClass(): string
    {
        return PointEntity::class;
    }
    public function getFormService(): PointForm
    {
        if ($this->_form === null) {
            $this->_form = new PointForm();
            $this->_form->setAttributes([
                'pk_field'         => $this->model->getPKField(),
                'title_field'      => $this->model->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_form;
    }
    public function getHelper(): PointHelper
    {
        if ($this->_helper === null) {
            $this->_helper = new PointHelper();
            $this->_helper->setAttributes([
                'pk_field'         => $this->model->getPKField(),
                'title_field'      => $this->model->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_helper;
    }
    public function action_init_process(string $action, array $formDatas = []): void
    {
        $fields = [
            "clientinfo_uid",
            "title",
            "amount",
            "status",
            "content",
        ];
        $filters = [
            "clientinfo_uid",
            "status",
        ];
        $indexFilter     = $filters;
        $batchjobFilters = ['status'];
        switch ($action) {
            case 'create':
            case 'create_form':
            case 'modify':
            case 'modify_form':
                break;
            case 'view':
                $fields = [...$fields, 'created_at'];
                break;
            case 'index':
            case 'download':
                $fields = [
                    "clientinfo_uid",
                    "title",
                    "amount",
                    "status",
                    'created_at'
                ];
                break;
        }
        $this->getFormService()->setFormFields($fields);
        $this->getFormService()->setFormRules($action, $fields);
        $this->getFormService()->setFormFilters($filters);
        $this->getFormService()->setFormOptions($action, $filters, $formDatas);
        $this->getFormService()->setIndexFilters($indexFilter);
        $this->getFormService()->setBatchjobFilters($batchjobFilters);
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): PointEntity
    {
        return $entity;
    }
    protected function create_process(array $formDatas): PointEntity
    {
        $entity = parent::create_process($formDatas);
        service('customer_clientservice')->updateBalance($entity->getClientInfoUID(), "포인트", PAYMENT['PAY']['POINT'], $entity->getAmount(), $entity->getStatus());
        return $entity;
    }
    protected function modify_process($entity, array $formDatas): PointEntity
    {
        throw new RuntimeException("포인트정보는 수정이 불가합니다.");
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
}
